-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2013 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions
-- and other software and tools, and its AMPP partner logic
-- functions, and any output files from any of the foregoing
-- (including device programming or simulation files), and any
-- associated documentation or information are expressly subject
-- to the terms and conditions of the Altera Program License
-- Subscription Agreement, Altera MegaCore Function License
-- Agreement, or other applicable license agreement, including,
-- without limitation, that your use is for the sole purpose of
-- programming logic devices manufactured by Altera and sold by
-- Altera or its authorized distributors.  Please refer to the
-- applicable agreement for further details.


-- Generated by Quartus II 32-bit Version 13.0 (Build Build 232 06/12/2013)
-- Created on Thu Jan 29 14:23:22 2015

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;
use ieee.std_logic_misc.all;


--  Entity Declaration

ENTITY UART_interface IS
-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
  PORT
    (
      reset : in std_logic;
      clk40     : in std_logic;
      UART_Rx  : in std_logic;
      UART_Tx : out std_logic;
      UART_Tx_en  : out std_logic;
      address : in std_logic_vector(3 downto 0);
      
      reg_out_0 : out std_logic_vector(15 downto 0);
      reg_out_1 : out std_logic_vector(15 downto 0);
      reg_out_2 : out std_logic_vector(15 downto 0);
      reg_out_3 : out std_logic_vector(15 downto 0);
      reg_out_4 : out std_logic_vector(15 downto 0);
      reg_out_5 : out std_logic_vector(15 downto 0);
      reg_out_6 : out std_logic_vector(15 downto 0);
      reg_out_7 : out std_logic_vector(15 downto 0);
      reg_out_8 : out std_logic_vector(15 downto 0);
      reg_out_9 : out std_logic_vector(15 downto 0);
      reg_out_10 : out std_logic_vector(15 downto 0);
      reg_out_11 : out std_logic_vector(15 downto 0);
      reg_out_12 : out std_logic_vector(15 downto 0);
      reg_out_13 : out std_logic_vector(15 downto 0);
      reg_out_14 : out std_logic_vector(15 downto 0);
      reg_out_15 : out std_logic_vector(15 downto 0);
      
      reg_in_0 : in std_logic_vector(15 downto 0);
      reg_in_1 : in std_logic_vector(15 downto 0);
      reg_in_2 : in std_logic_vector(15 downto 0);
      reg_in_3 : in std_logic_vector(15 downto 0);
      reg_in_4 : in std_logic_vector(15 downto 0);
      reg_in_5 : in std_logic_vector(15 downto 0);
      reg_in_6 : in std_logic_vector(15 downto 0);
      reg_in_7 : in std_logic_vector(15 downto 0);
      reg_in_8 : in std_logic_vector(15 downto 0);
      reg_in_9 : in std_logic_vector(15 downto 0);
      reg_in_10 : in std_logic_vector(15 downto 0);
      reg_in_11 : in std_logic_vector(15 downto 0);
      reg_in_12 : in std_logic_vector(15 downto 0);
      reg_in_13 : in std_logic_vector(15 downto 0);
      reg_in_14 : in std_logic_vector(15 downto 0);
      reg_in_15 : in std_logic_vector(15 downto 0)
      
      );
-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!

END UART_interface;


--  Architecture Body

ARCHITECTURE UART_interface_architecture OF UART_interface IS

  -----------------------------------------------------------------------------
  -- UART slave
  -----------------------------------------------------------------------------
  component uart_slave is
    port (
      clk40                   : in  std_logic;
      reset                   : in  std_logic;
      UART_Rx                 : in  std_logic;
      UART_Tx                 : out std_logic;
      UART_Tx_en              : out std_logic;
      hw_address              : in  std_logic_vector(1 downto 0);
      sw_address              : in  std_logic_vector(1 downto 0);
      register_address        : out std_logic_vector(3 downto 0);
      register_data_in        : in  std_logic_vector(15 downto 0);
      register_data_out       : out std_logic_vector(15 downto 0);
      register_data_out_valid : out std_logic);
  end component uart_slave;

  -----------------------------------------------------------------------------
  -- signals
  -----------------------------------------------------------------------------
  type register_block is array (0 to 15) of std_logic_vector(15 downto 0);
  constant UART_register_default : register_block := (x"0000",x"0000",x"FFFF",x"0000",x"FFFd",x"FFFe",x"FFFF",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000");
  signal UART_register : register_block := UART_register_default;
  signal UART_register_in : register_block := UART_register_default;

  signal data_out : std_logic_vector(15 downto 0) := x"0000";
  signal data_in : std_logic_vector(15 downto 0);
  signal register_address : std_logic_vector(3 downto 0);
  signal data_out_valid : std_logic := '0';
  
  
begin  -- Behavioral

  uart_slave_2: entity work.uart_slave
    port map (
      clk40                   => clk40,
      reset                   => reset,
      UART_Rx                 => UART_Rx,
      UART_Tx                 => UART_Tx,
      UART_Tx_en              => UART_Tx_en,
      hw_address              => address(1 downto 0),
      sw_address              => address(3 downto 2),
      register_address        => register_address,
      register_data_in        => data_in,
      register_data_out       => data_out,
      register_data_out_valid => data_out_valid);
  
  -- Map I/O ports to arrays
  UART_register_in(0) <= reg_in_0;
  UART_register_in(1) <= reg_in_1;
  UART_register_in(2) <= reg_in_2;
  UART_register_in(3) <= reg_in_3;
  UART_register_in(4) <= reg_in_4;
  UART_register_in(5) <= reg_in_5;
  UART_register_in(6) <= reg_in_6;
  UART_register_in(7) <= reg_in_7;
  UART_register_in(8) <= reg_in_8;
  UART_register_in(9) <= reg_in_9;
  UART_register_in(10) <= reg_in_10;
  UART_register_in(11) <= reg_in_11;
  UART_register_in(12) <= reg_in_12;
  UART_register_in(13) <= reg_in_13;
  UART_register_in(14) <= reg_in_14;
  UART_register_in(15) <= reg_in_15;
  
  reg_out_0 <= UART_register(0);
  reg_out_1 <= UART_register(1);
  reg_out_2 <= UART_register(2);
  reg_out_3 <= UART_register(3);
  reg_out_4 <= UART_register(4);
  reg_out_5 <= UART_register(5);
  reg_out_6 <= UART_register(6);
  reg_out_7 <= UART_register(7);
  reg_out_8 <= UART_register(8);
  reg_out_9 <= UART_register(9);
  reg_out_10 <= UART_register(10);
  reg_out_11 <= UART_register(11);
  reg_out_12 <= UART_register(12);
  reg_out_13 <= UART_register(13);
  reg_out_14 <= UART_register(14);
  reg_out_15 <= UART_register(15);

  
  -- allow the readout of the registers by the master
  register_read: process (clk40, reset)
  begin  -- process register_read
    if clk40'event and clk40 = '1' then  -- rising clock edge
      data_in <= UART_register_in(to_integer(unsigned(register_address)))(15 downto 0);
    end if;
  end process register_read;

  --allow the master to update the registers
  reg_write: process (clk40, reset) is
  begin  -- process reg_write
    if reset = '1' then                 -- asynchronous reset (active high)
      -- set to default values
      for iReg in 0 to 15 loop
        UART_register(iReg) <= UART_register_default(iReg);
      end loop;  -- iReg
    elsif clk40'event and clk40 = '1' then  -- rising clock edge
      --update a register if master sends the command
      if data_out_valid = '1' then
        UART_register(to_integer(unsigned(register_address))) <= data_out;
      end if;
    end if;
  end process reg_write;
 


END UART_interface_architecture;
